searchNodes=[{"doc":"Some common utility functions.","ref":"Bundlex.html","title":"Bundlex","type":"module"},{"doc":"Returns path where compiled native is stored.","ref":"Bundlex.html#build_path/2","title":"Bundlex.build_path/2","type":"function"},{"doc":"Returns family of the platform obtained with platform/0.","ref":"Bundlex.html#family/0","title":"Bundlex.family/0","type":"function"},{"doc":"Returns current platform name.","ref":"Bundlex.html#platform/0","title":"Bundlex.platform/0","type":"function"},{"doc":"Utilities to ease interaction with Bundlex-based CNodes, so they can be treated more like Elixir processes / GenServers.","ref":"Bundlex.CNode.html","title":"Bundlex.CNode","type":"module"},{"doc":"Makes a synchronous call to CNode and waits for its reply. The CNode is supposed to send back a {cnode, response} tuple where cnode is the node name of CNode. If the response doesn&#39;t come in within timeout, error is raised. Messages are exchanged directly (without interacting with CNode&#39;s associated server).","ref":"Bundlex.CNode.html#call/3","title":"Bundlex.CNode.call/3","type":"function"},{"doc":"Starts monitoring CNode from the calling process.","ref":"Bundlex.CNode.html#monitor/1","title":"Bundlex.CNode.monitor/1","type":"function"},{"doc":"Sends a message to cnode. The message is exchanged directly (without interacting with CNode&#39;s associated server).","ref":"Bundlex.CNode.html#send/2","title":"Bundlex.CNode.send/2","type":"function"},{"doc":"Spawns and connects to CNode cnode_name from application of calling module. See Bundlex.CNode.start/2 for more details.","ref":"Bundlex.CNode.html#start/1","title":"Bundlex.CNode.start/1","type":"macro"},{"doc":"Works the same way as start_link/2, but does not link to CNode&#39;s associated server.","ref":"Bundlex.CNode.html#start/2","title":"Bundlex.CNode.start/2","type":"function"},{"doc":"Spawns and connects to CNode cnode_name from application of calling module. See Bundlex.CNode.start_link/2 for more details.","ref":"Bundlex.CNode.html#start_link/1","title":"Bundlex.CNode.start_link/1","type":"macro"},{"doc":"Spawns and connects to CNode cnode_name from application app. The CNode is passed the following command line arguments: host name, alive name, node name, cookie, creation number. After CNode startup, these parameters should be passed to ei_connect_xinit function, and CNode should be published and await connection. Once the CNode is published, it should print a line starting with ready to the standard output and flush the standard output to avoid the line being buffered. Under the hood, this function starts an associated server, which is responsible for monitoring the CNode and monitoring calling process to be able to do proper cleanup upon a crash. On startup, the server does the following: Makes current node distributed if it is not done yet (see Node.start/3). Assigns CNode a unique name. Starts CNode OS process using Port.open/2. Waits (at most 5 seconds) until a line ready is printed out (this line is captured and not forwarded to the stdout). Connects to the CNode.","ref":"Bundlex.CNode.html#start_link/2","title":"Bundlex.CNode.start_link/2","type":"function"},{"doc":"Disconnects from CNode. It is the responsibility of the CNode to exit upon connection loss.","ref":"Bundlex.CNode.html#stop/1","title":"Bundlex.CNode.stop/1","type":"function"},{"doc":"","ref":"Bundlex.CNode.html#t:on_start_t/0","title":"Bundlex.CNode.on_start_t/0","type":"type"},{"doc":"Reference to the CNode. Consists of pid of CNode&#39;s associated server and CNode name.","ref":"Bundlex.CNode.html#t:t/0","title":"Bundlex.CNode.t/0","type":"type"},{"doc":"Some utilities to ease loading of Bundlex-based NIFs.","ref":"Bundlex.Loader.html","title":"Bundlex.Loader","type":"module"},{"doc":"Binds the module to the specified NIF. Accepts keyword list, that may contain two arguments: :nif - required, name of the NIF to be bound (the same as specified in bundlex.exs) :app - application defining the NIF, defaults to the current application After use&#39;ing this module you can utilize defnif/1 and defnifp/1 macros to create bindings to particular native functions. Example defmodule My.Native.Module do use Bundlex.Loader, nif: :my_nif defnif native_function(arg1, arg2, arg3) def normal_function(arg1, arg2) do # ... end defnifp private_native_function(arg1, arg2) end","ref":"Bundlex.Loader.html#__using__/1","title":"Bundlex.Loader.__using__/1","type":"macro"},{"doc":"Generates function bound to the native implementation. This module has to be used for this macro to work. Function name should correspond to the native one. See __using__/1 for examples.","ref":"Bundlex.Loader.html#defnif/1","title":"Bundlex.Loader.defnif/1","type":"macro"},{"doc":"Works the same way as defnif/1, but generates private function. This module has to be used for this macro to work. See __using__/1 for examples.","ref":"Bundlex.Loader.html#defnifp/1","title":"Bundlex.Loader.defnifp/1","type":"macro"},{"doc":"Binds calling module to NIF nif_name from application app. Second argument has to be an atom, the same as name of the NIF in the bundlex project. Invoked internally by __using__/1 macro, which is the preferred way of loading NIFs.","ref":"Bundlex.Loader.html#load_nif!/2","title":"Bundlex.Loader.load_nif!/2","type":"macro"},{"doc":"Behaviour that should be implemented by each project using Bundlex in the bundlex.exs file.","ref":"Bundlex.Project.html","title":"Bundlex.Project","type":"behaviour"},{"doc":"Returns the project struct of given application. If the module has not been loaded yet, it is loaded from project_dir/bundlex.exs file.","ref":"Bundlex.Project.html#get/1","title":"Bundlex.Project.get/1","type":"function"},{"doc":"Callback returning project configuration.","ref":"Bundlex.Project.html#c:project/0","title":"Bundlex.Project.project/0","type":"callback"},{"doc":"Determines if module is a bundlex project module.","ref":"Bundlex.Project.html#project_module?/1","title":"Bundlex.Project.project_module?/1","type":"function"},{"doc":"Type describing project configuration. It&#39;s a keyword list, where nifs, cnodes and libs can be specified. Libs are native packages that are compiled as static libraries and linked to natives that have them specified in deps field of their configuration.","ref":"Bundlex.Project.html#t:config_t/0","title":"Bundlex.Project.config_t/0","type":"type"},{"doc":"Type describing configuration of a native. It&#39;s a keyword list containing the following keys: sources - C files to be compiled (at least one must be provided), includes - Paths to look for header files (empty list by default). lib_dirs - Paths to look for libraries (empty list by default). libs - Names of libraries to link (empty list by default). pkg_configs - Names of libraries for which the appropriate flags will be obtained using pkg-config (empty list by default). deps - Dependencies in the form of {app, lib_name}, where app is the application name of the dependency, and lib_name is the name of lib specified in bundlex project of this dependency. src_base - Native files should reside in project_root/c_src/&lt;src_base&gt; (application name by default). compiler_flags - Custom flags for compiler. linker_flags - Custom flags for linker.","ref":"Bundlex.Project.html#t:native_config_t/0","title":"Bundlex.Project.native_config_t/0","type":"type"},{"doc":"","ref":"Bundlex.Project.html#t:native_name_t/0","title":"Bundlex.Project.native_name_t/0","type":"type"},{"doc":"Struct representing bundlex project. Contains the following fileds: :config - project configuration :src_path - path to the native sources :module - bundlex project module :app - application that exports project","ref":"Bundlex.Project.html#t:t/0","title":"Bundlex.Project.t/0","type":"type"},{"doc":"Builds natives specified in bundlex.exs file Accepts the following command line arguments: --store-scripts - if set, shell scripts are stored in the project root folder for further analysis. Add :bundlex to compilers in your Mix project to have this task executed each time the project is compiled.","ref":"Mix.Tasks.Compile.Bundlex.html","title":"Mix.Tasks.Compile.Bundlex","type":"task"},{"doc":"Module containing helper functions that ease determining path to locally- installed Erlang.","ref":"Bundlex.Helper.ErlangHelper.html","title":"Bundlex.Helper.ErlangHelper","type":"module"},{"doc":"Tries to determine paths to includes directory of locally installed Erlang.","ref":"Bundlex.Helper.ErlangHelper.html#get_includes/1","title":"Bundlex.Helper.ErlangHelper.get_includes/1","type":"function"},{"doc":"Tries to determine paths to libs directory of locally installed Erlang.","ref":"Bundlex.Helper.ErlangHelper.html#get_lib_dirs/1","title":"Bundlex.Helper.ErlangHelper.get_lib_dirs/1","type":"function"},{"doc":"Module simplifying interaction with Git.","ref":"Bundlex.Helper.GitHelper.html","title":"Bundlex.Helper.GitHelper","type":"module"},{"doc":"Determines whether the Git Large File Storage is activated on the current machine.","ref":"Bundlex.Helper.GitHelper.html#lfs_present?/0","title":"Bundlex.Helper.GitHelper.lfs_present?/0","type":"function"},{"doc":"Module containing helper functions that ease retreiving certain values from Mix configuration files.","ref":"Bundlex.Helper.MixHelper.html","title":"Bundlex.Helper.MixHelper","type":"module"},{"doc":"Helper function for retreiving app name from mix.exs and failing if it was not found.","ref":"Bundlex.Helper.MixHelper.html#get_app!/0","title":"Bundlex.Helper.MixHelper.get_app!/0","type":"function"},{"doc":"Returns app for the given module. In case of failure fallbacks to get_app!/0.","ref":"Bundlex.Helper.MixHelper.html#get_app!/1","title":"Bundlex.Helper.MixHelper.get_app!/1","type":"function"},{"doc":"Returns path to the priv dir for given application.","ref":"Bundlex.Helper.MixHelper.html#get_priv_dir/1","title":"Bundlex.Helper.MixHelper.get_priv_dir/1","type":"function"},{"doc":"Returns root directory of the currently compiled project.","ref":"Bundlex.Helper.MixHelper.html#get_project_dir/0","title":"Bundlex.Helper.MixHelper.get_project_dir/0","type":"function"},{"doc":"Returns root directory of the project of given application.","ref":"Bundlex.Helper.MixHelper.html#get_project_dir/1","title":"Bundlex.Helper.MixHelper.get_project_dir/1","type":"function"},{"doc":"Module containing helper functions that ease traversing directories.","ref":"Bundlex.Helper.PathHelper.html","title":"Bundlex.Helper.PathHelper","type":"module"},{"doc":"Fixes slashes in the given path to match convention used on current operating system. Internally all elixir functions use slash as a path separator, even if running on windows, and it&#39;s not a bug but a feature (lol). See https://github.com/elixir-lang/elixir/issues/1236","ref":"Bundlex.Helper.PathHelper.html#fix_slashes/1","title":"Bundlex.Helper.PathHelper.fix_slashes/1","type":"function"},{"doc":"Tries to find a path that matches given pattern that has the biggest version number if it is expected to be a suffix.","ref":"Bundlex.Helper.PathHelper.html#latest_wildcard/1","title":"Bundlex.Helper.PathHelper.latest_wildcard/1","type":"function"},{"doc":"Bundlex Bundlex is a multi-platform tool for compiling C code along with elixir projects, for use in NIFs and CNodes. The tool provides also convenient way of accessing compiled code in elixir modules. This tool is a part of Membrane Framework","ref":"readme.html","title":"Bundlex","type":"extras"},{"doc":"To install, you need to configure Mix project as follows: defmodule MyApp.Mixfile do use Mix.Project def project do [ app: :my_app, compilers: [:bundlex] ++ Mix.compilers, # add bundlex to compilers deps: deps(), # ... ] end defp deps() do [ {:bundlex, &quot;~&gt; 0.2.0&quot;} # add bundlex to deps ] end end and create bundlex.exs file in the project root folder, containing bundlex project module: defmodule Membrane.Element.Mad.BundlexProject do use Bundlex.Project def project() do [] end end Now your project does not contain any C sources, but should compile successfully, and some bundlex messages should be printed while compilation proceeds.","ref":"readme.html#instalation","title":"Bundlex - Instalation","type":"extras"},{"doc":"Adding natives to project Adding natives can be done in project/0 function of bundlex project module in the following way: defmodule MyApp.BundlexProject do use Bundlex.Project def project() do [ nifs: nifs(Bundlex.platform), cnodes: cnodes(), libs: libs() ] end defp nifs(:linux) do [ my_nif: [ sources: [&quot;something.c&quot;, &quot;linux_specific.c&quot;] ], my_other_nif: [ # ... ] ] end defp nifs(_platform) do [ my_nif: [ sources: [&quot;something.c&quot;, &quot;multiplatform.c&quot;] ], my_other_nif: [ # ... ] ] end defp cnodes() do [ my_cnode: [ sources: [&quot;something.c&quot;, &quot;something_other.c&quot;] ], my_other_cnode: [ # ... ] ] end defp libs(_platform) do [ my_lib: [ sources: [&quot;something.c&quot;, &quot;something_other.c&quot;] ], my_other_lib: [ # ... ] ] end end As we can see, there are three types of natives: NIFs - dynamically linked to the Erlang VM (see Erlang docs) CNodes - executed as separate OS processes, accessed through sockets (see Erlang docs) libs - can be used by other natives as dependencies (see deps option below) The sources should reside in project_root/c_src/my_app directory (this can be changed with src_base option, see below). Configuration of each native may contain following options: sources - C files to be compiled (at least one must be provided), includes - Paths to look for header files (empty list by default). lib_dirs - Absolute paths to look for libraries (empty list by default). libs - Names of libraries to link (empty list by default). pkg_configs - Names of libraries for which the appropriate flags will be obtained using pkg-config (empty list by default). deps - Dependencies in the form of {app, lib_name}, where app is the application name of the dependency, and lib_name is the name of lib specified in bundlex project of this dependency. src_base - Native files should reside in project_root/c_src/&lt;src_base&gt; (application name by default). compiler_flags - Custom flags for compiler. linker_flags - Custom flags for linker. Compilation options The following command line arguments can be passed: --store-scripts - if set, shell scripts are stored in the project root folder for further analysis. Loading NIFs in modules NIFs compiled with Bundlex can be loaded the same way as any other NIFs (see :erlang.load_nif/2), but Bundlex provides Bundlex.Loader module to save you some boilerplate: defmodule MyApp.SomeNativeStuff do use Bundlex.Loader, nif: :my_nif def normal_function(a, b, c, d) do private_native_function(a+b, c+d) end defnif native_function(a, b) defnifp private_native_function(x, y) end Note that unlike when using :erlang.load_nif/2, here defs and defps can be used to create usual functions, native ones are declared with defnif and defnifp. This is achieved by creating a new module under the hood, and that is why module passed to C macro ERL_NIF_INIT has to be succeeded by .Nif, i.e. ERL_NIF_INIT(MyApp.SomeNativeStuff.Nif, funs, load, NULL, upgrade, unload) In spite of this, any native erlang macros and functions shall be used as usual, as described at http://erlang.org/doc/man/erl_nif.html Interacting with CNodes As in case of NIFs, CNodes compiled with Bundlex can be used like any other CNodes (see built-in Node module), while some useful stuff for interacting with them is provided. Bundlex.CNode module contains utilities that make it easier to spawn and control CNodes, and allow to treat them more like usual Elixir processes. Check out documentation for more details.","ref":"readme.html#usage","title":"Bundlex - Usage","type":"extras"},{"doc":"Copyright 2018, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Bundlex - Copyright and License","type":"extras"}]